﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Threading;
using AtmaHunter.Settings;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using Newtonsoft.Json;
using System.Net;
using System.Net.Sockets;
using System.Net.Mail;
using System.Net.Mime;
using System.Security.Cryptography;
using System.Text;


namespace AtmaHunter
{
    public class AtmaHunter : IBotPlugin
    {
        #region Necessary Stuff
        private AtmaHunterForm _form;
        public string Author { get { return "Exmortem (Original Work)"; } }
        public Version Version { get { return new Version(1, 2); } }
        public string Name { get { return "AtmaHunter"; } }
        public string Description { get { return "Finishes Atma collection for you."; } }
        public long iTotalAtma = 0;
        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "AtmaHunter"; }
        }
        public void OnButtonPress()
        {
            if (_form == null || _form.IsDisposed || _form.Disposing)
                _form = new AtmaHunterForm();

            _form.ShowDialog();  
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion
        public void OnPulse()
        {
            if (BotManager.Current.Name == "Fate Bot")
            {
                if (!FateManager.WithinFate)
                {
                    AlertNewDrop();
                    ChangeZone();
                }
            }
        }

        List<Int32> Atmas = new List<Int32>();
        List<string> Inventory = new List<string>();

        Dictionary<int, Int32> AtmaDictionary = new Dictionary<int, Int32>();
        Dictionary<uint, string> AtmaDictionaryText = new Dictionary<uint, string>();
        public static AtmaHunterSettings settings = AtmaHunterSettings.instance;

        public void OnInitialize()
        {
            #region Atma List
            Atmas.Add(7851);
            Atmas.Add(7860);
            Atmas.Add(7854);
            Atmas.Add(7852);
            Atmas.Add(7855);
            Atmas.Add(7857);
            Atmas.Add(7861);
            Atmas.Add(7853);
            Atmas.Add(7856);
            Atmas.Add(7858);
            Atmas.Add(7859);
            Atmas.Add(7862);
            #endregion
            #region Atma Dictionary
            AtmaDictionary.Add(1, 7851);
            AtmaDictionary.Add(2, 7852);
            AtmaDictionary.Add(3, 7853);
            AtmaDictionary.Add(4, 7854);
            AtmaDictionary.Add(5, 7855);
            AtmaDictionary.Add(6, 7856);
            AtmaDictionary.Add(7, 7857);
            AtmaDictionary.Add(8, 7858);
            AtmaDictionary.Add(9, 7859);
            AtmaDictionary.Add(10, 7860);
            AtmaDictionary.Add(11, 7861);
            AtmaDictionary.Add(12, 7862);
            AtmaDictionary.Add(13, 7851);
            AtmaDictionary.Add(14, 7852);
            AtmaDictionary.Add(15, 7853);
            AtmaDictionary.Add(16, 7854);
            AtmaDictionary.Add(17, 7855);
            AtmaDictionary.Add(18, 7856);
            AtmaDictionary.Add(19, 7857);
            AtmaDictionary.Add(20, 7858);
            AtmaDictionary.Add(21, 7859);
            AtmaDictionary.Add(22, 7860);
            AtmaDictionary.Add(23, 7861);
            AtmaDictionary.Add(0, 7862);
            #endregion
            #region Atma Dictionary
            AtmaDictionaryText.Add(3, "Atma of the Maiden");
            AtmaDictionaryText.Add(7, "Atma of the Archer");
            AtmaDictionaryText.Add(4, "Atma of the Goat");
            AtmaDictionaryText.Add(20, "Atma of the Scorpion");
            AtmaDictionaryText.Add(18, "Atma of the Bull");
            AtmaDictionaryText.Add(17, "Atma of the Twins");
            AtmaDictionaryText.Add(53, "Atma of the Scales");
            AtmaDictionaryText.Add(15, "Atma of the Water-bearer");
            AtmaDictionaryText.Add(52, "Atma of the Ram");
            AtmaDictionaryText.Add(16, "Atma of the Lion");
            AtmaDictionaryText.Add(10, "Atma of the Fish");
            AtmaDictionaryText.Add(14, "Atma of the Crab");
            #endregion
            ExistingAtma();
        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {

        }
        public void OnDisabled()
        {

        }

        #region Atmas
        public void ChangeZone()
        {
            #region Gather By Which You're Missing.
            if (!settings.UseJSTTheory)
            {
                if (NextLocation() == 0)
                {
                    Logging.Write("[Atma Hunter] You have a full set of Atmas.");
                    return;
                }

                if (CurrentLocation(WorldManager.ZoneId) == NextLocation())
                {
                    return;
                }

                TreeRoot.Stop();

                if (Core.Player.IsMounted)
                {
                    Actionmanager.Dismount();
                    Thread.Sleep(1000);
                }

                if (CurrentLocation(WorldManager.ZoneId) != NextLocation())
                {
                    Logging.Write("[Atma Hunter] Moving to " + NextLocation());
                    if (NextLocation() == 4)
                        WorldManager.TeleportById(4);
                    else
                        WorldManager.TeleportById(NextLocation());
                    Thread.Sleep(15000);
                    TreeRoot.Start();

                }
            }

            #endregion
            #region JST Time Theory Method
            if (settings.UseJSTTheory)
            {
                if (CurrentLocation(WorldManager.ZoneId) == NextTimeLocation())
                {
                    return;
                }

                TreeRoot.Stop();

                if (Core.Player.IsMounted)
                {
                    Actionmanager.Dismount();
                    Thread.Sleep(1000);
                }

                if (CurrentLocation(WorldManager.ZoneId) != NextTimeLocation())
                {
                    Logging.Write("[Atma Hunter] Current JST time is " + DateTime.UtcNow.AddHours(9).Hour);
                    Logging.Write("[Atma Hunter] Moving to " + NextTimeLocation());

                    if (NextTimeLocation() == 152)
                        WorldManager.TeleportById(4);
                    else
                        WorldManager.TeleportById(NextTimeLocation());

                    Thread.Sleep(15000);
                    TreeRoot.Start();

                }
            }

            #endregion
        }
        public uint NextTimeLocation()
        {
            Int32 atma = AtmaDictionary[DateTime.UtcNow.AddHours(9).Hour];

            switch (atma)
            {
                case 7851://Atma of the Maiden
                    return 3;//Bentbranch Meadows

                case 7860://Atma of the Archer
                    return 7; //Fallgourd Float

                case 7854://Atma of the Goat
                    return 4;//The Hawthorne Hut

                case 7852://Atma of the Scorpion
                    return 20;//Forgotten Springs

                case 7855://Atma of the Bull
                    return 18;//Camp Drybone

                case 7857://Atma of the Twins
                    return 17;//Horizon

                case 7861://Atma of the Scales
                    return 53;//Black Brush Station

                case 7853://Atma of the Water-bearer
                    return 15;//Camp Bronze Lake

                case 7856://Atma of the Ram
                    return 52;//Summerford Farms

                case 7858://Atma of the Lion
                    return 16;//Camp Overlook

                case 7859://Atma of the Fish
                    return 10;//Moraby Drydocks

                case 7862://Atma of the Crab
                    return 14;//Aleport

                default:
                    return 0;
            }
        }

        public void AlertNewDrop()
        {
            if (CheckifNewDrop())
            {
                try
                {
                    if (settings.PlaySound)
                    {
                        System.Media.SoundPlayer player = new System.Media.SoundPlayer(settings.SoundFile);
                        player.Play();
                    }
                }
                catch (Exception ex)
                {
                    Logging.Write("Failed to play the sound.");
                }

                try
                {
                    if (settings.SendSMS)
                        SendText();
                }
                catch (Exception ex)
                {
                    Logging.Write("Failed to send email.");
                }
            }

        }

        public bool CheckifNewDrop()
        {
            long iCurrent = CurrentAtma();
            if (iCurrent > iTotalAtma)
            {
                iTotalAtma = iCurrent;
                return true;
            }
            return false;
        }

        public void ExistingAtma()
        {
            string sItemName = "";

            foreach (BagSlot a in InventoryManager.FilledSlots)
            {
                sItemName = a.Name;
                if (sItemName.StartsWith("Atma "))
                {
                    iTotalAtma = iTotalAtma + InventoryManager.ItemCount(a.Item);
                }

            }

        }

        public long CurrentAtma()
        {
            string sItemName = "";
            long iCurrentCount = 0;

            foreach (BagSlot a in InventoryManager.FilledSlots)
            {
                sItemName = a.Name;
                if (sItemName.StartsWith("Atma "))
                    iCurrentCount = iCurrentCount + InventoryManager.ItemCount(a.Item);

            }

            return iCurrentCount;
        }

        public uint NextLocation()
        {
            Int32 atma = 0;
            int jstAtma = AtmaDictionary[DateTime.UtcNow.AddHours(9).Hour];

            Inventory.Clear();

            foreach (BagSlot a in InventoryManager.FilledSlots)
            {
                Inventory.Add(a.TrueItemId.ToString());
            }

            if (!Inventory.Contains(jstAtma.ToString()))
            {
                return GetLocationName(jstAtma);
            }

            foreach (Int32 a in Atmas)
            {
                if (!Inventory.Contains(a.ToString()))
                    atma = a;
            }

            return GetLocationName(atma);
        }

        private static uint GetLocationName(Int32 atma)
        {
            switch (atma)
            {
                case 7851://Atma of the Maiden
                    return 3;//Bentbranch Meadows

                case 7860://Atma of the Archer
                    return 7; //Fallgourd Float

                case 7854://Atma of the Goat
                    return 4;//The Hawthorne Hut

                case 7852://Atma of the Scorpion
                    return 20;//Forgotten Springs

                case 7855://Atma of the Bull
                    return 18;//Camp Drybone

                case 7857://Atma of the Twins
                    return 17;//Horizon

                case 7861://Atma of the Scales
                    return 53;//Black Brush Station

                case 7853://Atma of the Water-bearer
                    return 15;//Camp Bronze Lake

                case 7856://Atma of the Ram
                    return 52;//Summerford Farms

                case 7858://Atma of the Lion
                    return 16;//Camp Overlook

                case 7859://Atma of the Fish
                    return 10;//Moraby Drydocks

                case 7862://Atma of the Crab
                    return 14;//Aleport

                default:
                    return 0;
            }
        }
        public uint CurrentLocation(uint zoneid)
        {
            switch (zoneid)
            {
                case 148:
                    return 3;// "Bentbranch Meadows";//148;

                case 154:
                    return 7;// "Fallgourd Float"; //154;

                case 152:
                    return 4;// "The Hawthorne Hut";//152;

                case 146:
                    return 20;// "Forgotten Springs";//146;

                case 145:
                    return 18;// "Camp Drybone";//145;

                case 140:
                    return 17;// "Horizon";//140;

                case 141:
                    return 53;// "Black Brush Station";//141;

                case 139:
                    return 15;// "Camp Bronze Lake";//139;

                case 134:
                    return 52;// "Summerford Farms";//134;

                case 180:
                    return 16;// "Camp Overlook";//180;

                case 135:
                    return 10;// "Moraby Drydocks";//135;

                case 138:
                    return 14;// "Aleport";//138;

                default:
                    return 0;
            }
        }

        private void SendText()
        {
            try
            {
                MailMessage mail = new MailMessage();
                SmtpClient SmtpServer = new SmtpClient(settings.SMTPServer);

                mail.From = new MailAddress(settings.FromEmail);
                mail.To.Add(settings.TextEmail);
                mail.Subject = AtmaDictionaryText[CurrentLocation(WorldManager.ZoneId)];
                mail.Body = "Atma Found";

                SmtpServer.Port = Convert.ToInt16(settings.SMTPPort);

                if (settings.LoginPassword != null && settings.KeyString != null)
                    SmtpServer.Credentials = new System.Net.NetworkCredential(settings.LoginName, Decrypt(settings.LoginPassword, settings.KeyString));
                SmtpServer.EnableSsl = settings.SMTPUseSSL;

                SmtpServer.Send(mail);
            }
            catch (Exception ex)
            {
                Logging.Write(ex.StackTrace);
            }
        }

        private string Decrypt(string encryptedText, string KeyString)
        {
            RijndaelManaged aesEncryption = new RijndaelManaged();
            aesEncryption.KeySize = 256;
            aesEncryption.BlockSize = 128;
            aesEncryption.Mode = CipherMode.ECB;
            aesEncryption.Padding = PaddingMode.ISO10126;
            byte[] KeyInBytes = Encoding.UTF8.GetBytes(KeyString);
            aesEncryption.Key = KeyInBytes;
            ICryptoTransform decrypto = aesEncryption.CreateDecryptor();
            byte[] encryptedBytes = Convert.FromBase64CharArray(encryptedText.ToCharArray(), 0, encryptedText.Length);
            return ASCIIEncoding.UTF8.GetString(decrypto.TransformFinalBlock(encryptedBytes, 0, encryptedBytes.Length));
        }

        #endregion
    }
 }

namespace AtmaHunter.Settings
{
    public class AtmaHunterSettings : JsonSettings
    {
        [JsonIgnore]
        private static AtmaHunterSettings _instance;
        public static AtmaHunterSettings instance { get { return _instance ?? (_instance = new AtmaHunterSettings("AtmaHunterSettings")); } }
        public AtmaHunterSettings(string filename) : base(Path.Combine(CharacterSettingsDirectory, "AtmaHunter.json")) { }

        [Setting]
        [DefaultValue(false)]
        public bool UseJSTTheory { get; set; }
        public string SMTPServer { get; set; }
        public string SMTPPort { get; set; }
        public bool SMTPUseSSL { get; set; }
        public string LoginName { get; set; }
        public string LoginPassword { get; set; }
        public string TextEmail { get; set; }
        public string FromEmail { get; set; }
        public bool SendSMS { get; set; }
        public string KeyString { get; set; }
        public bool PlaySound { get; set; }
        public string SoundFile { get; set; }



    }
}

